﻿@page "/product/create"

<Accelist.BlazorRAD.SmartForm TModel="ProductCreateEditFormModel"
                              @bind-Model="Form"
                              OnValidSubmit="Submit"
                              OnAfterSubmit="Reset"
                              Validate="true"
                              CustomizeSuccessMessage="SuccessMessage"
                              SelectOptionMethods="SelectOptions">
</Accelist.BlazorRAD.SmartForm>

@using Accelist.BlazorRAD
@code {
    [Inject]
    public IDbContextFactory<ShopDbContext> DbFactory { set; get; }

    public ProductCreateEditFormModel Form { set; get; } = new ProductCreateEditFormModel();

    public async Task Submit()
    {
        using var db = DbFactory.CreateDbContext();

        db.Products.Add(new Product
        {
            ProductID = Guid.NewGuid(),
            Name = Form.Name,
            Price = Form.Price
        });
        await db.SaveChangesAsync();
    }

    public void Reset()
    {
        Form = new ProductCreateEditFormModel();
    }

    public string SuccessMessage(ProductCreateEditFormModel model)
    {
        return "Successfully created new product: " + model.Name;
    }

    SelectOptionMethods SelectOptions { set; get; } = new SelectOptionMethods();

    protected override async Task OnInitializedAsync()
    {
        SelectOptions[nameof(Form.Category)] = GetCategoryOptions;
        SelectOptions[nameof(Form.Fragile)] = GetFragileOptions;
        SelectOptions[nameof(Form.Bundle)] = GetBundleOptions;
        SelectOptions[nameof(Form.Brand)] = GetBrandOptions;
        SelectOptions[nameof(Form.Brand2)] = GetBrandOptions;

        await Task.CompletedTask;
    }

    async Task<List<SelectOption>> GetCategoryOptions(string input)
    {
        var options = new List<SelectOption>();
        options.Add(new SelectOption
        {
            Name = "Laptop",
            Value = "cdead694-655f-499a-82df-09c4df5fe202"
        });
        options.Add(new SelectOption
        {
            Name = "Computer Parts",
            Value = "3ea2489f-d222-4a6b-ab58-a0926a41fb3f"
        });
        return await Task.FromResult(options);
    }

    async Task<List<SelectOption>> GetFragileOptions(string input)
    {
        var options = new List<SelectOption>();
        options.Add(new SelectOption
        {
            Name = "Fragile",
            Value = "Fragile"
        });
        options.Add(new SelectOption
        {
            Name = "Non-Fragile",
            Value = "Non-Fragile"
        });
        return await Task.FromResult(options);
    }

    async Task<List<SelectOption>> GetBundleOptions(string input)
    {
        var options = new List<SelectOption>();
        options.Add(new SelectOption
        {
            Name = "McAfee",
            Value = "1"
        });
        options.Add(new SelectOption
        {
            Name = "Microsoft Office 365",
            Value = "2"
        });
        return await Task.FromResult(options);
    }

    async Task<List<SelectOption>> GetBrandOptions(string input)
    {
        //anggep aja ada database...

        var options = new List<SelectOption>();
        options.Add(new SelectOption
        {
            Name = "Asus",
            Value = "1"
        });
        options.Add(new SelectOption
        {
            Name = "Acer",
            Value = "2"
        });
        options.Add(new SelectOption
        {
            Name = "Apple",
            Value = "3"
        });
        options.Add(new SelectOption
        {
            Name = "Samsung",
            Value = "4"
        });

        if (string.IsNullOrEmpty(input))
        {
            return options;
        }

        // pura pura dari SQL atau TypeSense atau Elastic
        var result = options.Where(Q => Q.Name.ToLower().StartsWith(input.ToLower())).ToList();

        return await Task.FromResult(result);
    }
}
